#!/usr/bin/env python3

"""
Получить следующий скрипт для выполнения первоначальной настройки
"""
import sys
from os import listdir
from os.path import isfile, join, basename

def getScripts(dir):
    return [join(dir, scr) for scr in listdir(dir) if isfile(join(dir, scr))]

def getExecutedScripts(filePath):
    executedScripts = []
    if isfile(filePath):
        with open(filePath) as file:
            executedScripts = [scr[:-1] for scr in file.readlines()]
    return executedScripts

def getFirstNotExecuted(scriptFiles, executedScripts):
    for scr in scriptFiles:
        bname = basename(scr)
        if not bname[bname.find('_')+1:] in executedScripts:
            return scr
    return 'None'

def main():
    if len(sys.argv) == 3:
        print(getFirstNotExecuted(sorted(getScripts(sys.argv[1])), getExecutedScripts(sys.argv[2])))
    else:
        sys.exit(1)

if __name__ == "__main__":\
    main()