#!/bin/bash

clear
path="/linuxcash/cash/data/artix-custom"
if [ ! -d  "$path" ]
then
    echo "directory $path not found."
    exit 0
fi

files=`ls "$path" | egrep '*.tar.gz'`

numberOfFiles=`echo ${#files}` 
if [ $numberOfFiles == 0 ]
then
   	echo "tar gz files not found"
   	exit 0
fi

messageView() 
{	
	dialog --backtitle "ИНИЦИАЛИЗАЦИЯ ПРОФИЛЯ" --infobox "Подождите! идет загрузка профиля." 0 0	
	cd /
	tar xfz $path/$1.tar.gz
}

listView()
{
	ext=".tar.gz"
    text=''
    order=0
    temp=/tmp/tmp.txt
    ''>$temp
    for fname in $files; do    	
    	(( order = order + 1 ))
		name=`basename "$fname" "$ext"`
		echo $order $name >> $temp
		text=$text' '$order' '$name
    done
    trap "rm -f /tmp/output.txt" 0 1 2 5 15
	dialog --backtitle "ИНИЦИАЛИЗАЦИЯ ПРОФИЛЯ" --menu "Выберите профиль системы" 0 0 0  $text 2>/tmp/output.txt
	retval=$?	

	case $retval in
    0)

	clear
	a="`cat /tmp/output.txt`"
	b=`cat $temp | egrep '^('$a' )'`	
	messageView `echo ${b:2}`
    ;;
    1)
	;;
    255)
	;;
	esac
	rm $temp	
}

if [ "$1" = "m" ]
then 
	listView
else
	if [ -f  "$path/custom_default.tar.gz" ]
	then    
    	messageView 'custom_default'
    else
    	listView
	fi

fi




