#!/usr/bin/env python3

import configparser

class Config(object):
    def __init__(self, filenames):
        self.conf = configparser.RawConfigParser()
        self.conf.read(filenames)

    def getBool(self, section, option, defaultValue):
        try:
            return self.conf.getboolean(section, option)
        except:
            pass
        return defaultValue

    def getInt(self, section, option, defaultValue):
        value = defaultValue
        try:
            return self.conf.getint(section, option)
        except:
            pass
        return defaultValue

    def getString(self, section, option, defaultValue):
        try:
            return self.conf.get(section, option)
        except:
            pass
        return defaultValue
