#!/usr/bin/env python3

import logging

class Logger(object):
    """
    Простейший логгер
    """
    _instance = None
    def __new__(cls, *args, **kwargs):
        if not cls._instance:
            cls._instance = super(Logger, cls).__new__(cls, *args, **kwargs)
            logging.basicConfig(filename='/linuxcash/logs/current/artix-tools.log',
                    format='%(asctime)s %(levelname)s - %(message)s', level=logging.INFO)
        return cls._instance

    def info(self, message):
        logging.info(message)

    def error(self, message):
        logging.error(message)

    def warn(self, message):
        logging.warning(message)
