#Скрипт для редактирования настроек сетевого интерфейса, имя которого передается во входных параметрах
#Выводит содержимое измененного файла /etc/network/interfaces в стандартный поток вывода


#записать первую строчку конфигурации интерфейса (пример: iface eth0 inet static)
#@param device имя интерфейса
#@param mode тип настройки (dhcp / static)
function writeHead(device, mode, is_auto) {
	if (!is_auto) {
		print "\nauto", device;
		print "iface", device, "inet", mode;
		is_auto = 1;
	} else {
		print "iface", device, "inet", mode;
	}
}


#записать настройки для интерфейса, настраиваемого статически
#@param addr ip-адрес
#@param nw адрес сети
#@param nm маска сети
#@param gw шлюз
function writeStatic(addr, nw, nm, gw) {
    if (length(addr))
        print "address", addr

    if (length(nw))
        print "network", nw

    if (length(nm))
        print "netmask", nm

    if (length(gw))
        print "gateway", gw

}

#запись настроек WPA для Wireless интерфейса
#@param ssid имя точки доступа
#@param driver драйвер
#@param scan параметр вещания имени точки доступа
#@param proto протокол
#@param pairwise шифрование
#@param group шифрование
#@param key_mgmt режим аутентификации
#@param psk hex-ключ

function writeWPA(ssid, driver, scan, proto, pairwise, group, key_mgmt, psk) {
    if (length(ssid))
        print "wpa-ssid", ssid

    if (length(driver))
        print "wpa-driver", driver

    if (length(scan))
        print "wpa-ap-scan", scan

    if (length(proto))
        print "wpa-proto", proto

    if (length(pairwise))
        print "wpa-pairwise", pairwise

    if (length(group))
        print "wpa-group", group

    if (length(key_mgmt))
        print "wpa-key-mgmt", key_mgmt

    if (length(psk))
        print "wpa-psk", psk
}


#записать настрйоки для интерфейса ppp
#@param provider
function writePPP(provider) {
    if (length(provider))
        print "provider", provider
}


#вывести информацию о входных аргументах для скрипта
function usage() {
        print "awk -f changeInterfaces.awk <interfaces file> device=<eth device> \n" \
            "       [address=<ip addr>] [gateway=<ip addr>] [netmask=<ip addr>]\n" \
            "       [network=<ip addr>] [mode=dhcp|static|ppp] [arg=debug] [remove=true]\n" \
            " WiFi(WPA/WPA2): [wpa_ssid=<access point name>] [wpa_driver=wext|madwifi|wired|atmel]\n" \
            "       [wpa_ap_scan=1|2] [wpa_proto=WPA|RSN] [wpa_pairwise=TKIP|CCMP]\n" \
            "       [wpa_group=TKIP|CCMP] [wpa_key_mgmt=WPA-PSK|WPA-EAP] [wpa_psk=<key>]\n"
}


BEGIN {
	start = 0;

    if (ARGC < 3 || ARGC > 20) {
        usage();
        exit 1;
    }

	#флаги проверки, были эти параметры переданы в качестве аргументов и были ли записаны в выходной файл
	#используются только для статической настройки
	#значения параметра:
	#0 - параметра не было во входных аргументах
	#1 - параметр был во входных аргументах, но не был записан в выходной файл
	#2 - параметр был во входных аргументах и был записан в выходной файл
	is_address = 0;
	is_netmask = 0;
	is_gateway = 0;
	is_network = 0;

	#флаг проверки, был ли записан в исходный файл интерфейс, передаваемый в качестве параметра
	#этот флаг требуется, если интерфейса изначально не было в файле
	is_writed = 0;
	is_auto = 0;
	is_current = 0;

    #флаг удаления интерфейса
    is_remove = 0;

	#читаем входные параметры и формируем поля для заполнения
    for (i = 2; i < ARGC; i++) {
        split(ARGV[i], pair, "=");
        if (pair[1] == "address") {
            address = pair[2];
            is_address = 1;
            static = 1;
        }
        else if (pair[1] == "gateway") {
            gateway = pair[2];
            is_gateway = 1;
            static = 1;
        }
        else if (pair[1] == "network") {
            network = pair[2];
            is_network = 1;
            static = 1;
        }
        else if (pair[1] == "netmask") {
            netmask = pair[2];
            is_netmask = 1;
            static = 1;
        }
        else if (pair[1] == "device") {
            device = pair[2];
        }
        else if (pair[1] == "provider") {
            provider = pair[2];
            ppp = 1;
        } 
        else if (pair[1] == "wpa_ssid") {
            wpa_ssid = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_driver") {
            wpa_driver = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_ap_scan") {
            wpa_ap_scan = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_proto") {
            wpa_proto = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_pairwise") {
            wpa_pairwise = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_group") {
            wpa_group = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_key_mgmt") {
            wpa_key_mgmt = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "wpa_psk") {
            wpa_psk = pair[2]
            wpa = 1;
        }
        else if (pair[1] == "arg" && pair[2] == "debug")
            debug = 1;
        else if (pair[1] == "remove" && pair[2] == "true")
            is_remove = 1;
        else if (pair[1] == "mode" && pair[2] == "dhcp")
            dhcp = 1;
        else if (pair[1] == "mode" && pair[2] == "static")
            static = 1;
        else if (pair[1] == "mode" && pair[2] == "ppp")
            ppp = 1;
        else {
            usage();
            exit 1;
        }
    }

    if (dhcp && static) {
        print "Both DHCP and static properties are defined";
        usage();
        exit 1;
    }
}

{
    #если текущая строка содержит auto, смотрим, есть ли там наш интерфейс
    if ($1 == "auto") {
    	for(i = 2; i <= NF; i++) {
    		if ($i == device) {
                if (is_remove) {
                    next;
                } else {
                    is_auto = 1;
                }
    		}
    	}

		print $0;
    	next;
    }

    if ($1 == "iface")  {

    	is_current = 0;

        # Ethernet name matches - switch the line scanning on
        if ($2 == device) {

            if (is_remove) {
                is_current = 1;
                is_writed = 1;
                next;
            }

            if (debug)
                print $0;

			if (static) {
			
				is_writed = 1;
				is_current = 1;
				writeHead(device, "static", is_auto);
				writeStatic(address, network, netmask, gateway);
               if (wpa)
                    writeWPA(wpa_ssid, wpa_driver, wpa_ap_scan, wpa_proto, wpa_pairwise, wpa_group, wpa_key_mgmt, wpa_psk);
				print "";
				
			} else if (dhcp) {
			
				is_writed = 1;
				is_current = 1;
				writeHead(device, "dhcp", is_auto);
                if (wpa)
                    writeWPA(wpa_ssid, wpa_driver, wpa_ap_scan, wpa_proto, wpa_pairwise, wpa_group, wpa_key_mgmt, wpa_psk);
				print "";
				
			} else if (ppp) {

                is_writed = 1;
                is_current = 1;
                writeHead(device, "ppp", is_auto);
                writePPP(provider);
				print "";
            }
		}
	}

	if (is_current) {
		next;
	} else {
		print $0;
		next;
	}
}

END {
	#если добавляемый интерфейс не присутстовал в interfaces, добавляем его в конце
	if (!is_writed) {
		if (static) {
			writeHead(device, "static", is_auto);
			writeStatic(address, network, netmask, gateway);
            if (wpa)
                writeWPA(wpa_ssid, wpa_driver, wpa_ap_scan, wpa_proto, wpa_pairwise, wpa_group, wpa_key_mgmt, wpa_psk);

			print ""
		} else if (dhcp) {
			writeHead(device, "dhcp", is_auto);
            if (wpa)
                writeWPA(wpa_ssid, wpa_driver, wpa_ap_scan, wpa_proto, wpa_pairwise, wpa_group, wpa_key_mgmt, wpa_psk);
			print ""
		} else if (ppp) {
            writeHead(device, "ppp", is_auto);
            writePPP(provider);
			print ""
        }
	}
	exit 0;
}

