#Скрипт для получения настроек сетевого интерфейса, имя которого передается во входных параметрах


#вывести информацию о входных аргументах для скрипта
function usage() {
        print "awk -f get.awk <interfaces file> device=<eth device> \n"
}

BEGIN {
	start = 0;

    if (ARGC != 3) {
        usage();
        exit 1;
    }

	#флаг проверки, был ли найден в файле интерфейс, передаваемый в качестве параметра
	is_found = 0;

	dhcp = 0;
	static = 0;
    ppp = 0;

    for (i = 2; i < ARGC; i++) {
        split(ARGV[i], pair, "=");
       	if (pair[1] == "device") {
            device = pair[2];
        }
        else {
            usage();
            exit 1;
        }
    }
}

{

    if ($1 == "auto") {
        static = 0;
        dhcp = 0;
        ppp = 0;
    }

    # Look for iface line and if the interface comes with the device name
    # scan whether it is dhcp or static
    if ($1 == "iface")  {

        # Ethernet name matches - switch the line scanning on
        if ($2 == device) {

        	is_found = 1;

            # It's a DHCP interface, if defined any static properties
            # change it to static
            if (match($0, / dhcp/)) {
                dhcp = 1;
                print "mode dhcp";
                next;
            }
            # It's a static network interface
            else if (match ($0, / static/)) {
                static = 1;
                print "mode static";
                next;
            }
            else if (match ($0, / ppp/)) {
                ppp = 1;
                print "mode ppp";
                next;
            }
        }
        else {
        	static = 0;
        	dhcp = 0;
            ppp = 0;
    	}
    }

	if (dhcp) {
		print $1, $2;
	}

	if (static) {
		print $1, $2;
	}

    if (ppp) {
        print $1, $2;
    }
	
    next;
}

END {
	
}

