#!/usr/bin/env python3

import os
import subprocess
import sys
sys.path.append("/linuxcash/cash/tools/tools_avail")
from dialog import Dialog
from py_tools.logger import logger

log = logger.Logger()

def main():
    log.info("Обновление конфигурации")
    try:
        d = Dialog()
        d.add_persistent_args(("--backtitle", "Обновление конфигурации"))
        run = not d.yesno("Выполнить обновление конфигурации?", height = 7)
        while run:
            puppetCode = subprocess.call("/linuxcash/cash/tools/tools_avail/artix_configure.sh", shell=True)

            if puppetCode:
                if d.yesno("Повторить попытку?", height = 7):
                    run = False
            else:
                run = False
        log.info("Завершение обновления конфигурации")
    except KeyboardInterrupt:
        log.warn("Неожиданное завершение обновления конфигурации")
        exit(0)

if __name__ == "__main__":
    os.chdir(os.path.dirname(os.path.abspath(__file__)))
    main()
