#!/usr/bin/env python3

class Wizard:
	"""Класс визарда"""

	def __init__(self):
		self.currentStep = 0
		self.oldStep = 0
		self.dialogs = []

	def run(self):
		"""Запуск визарда"""
		self.currentStep = 0
		self.isExit = False
		while self.isExit == False:
			self.showCurrentDialog()

	def nextForDialog(self, dialogName, value = None):
		"""Перейти на следующий шаг с диалога dialogName"""
		step = 0
		for dialog in self.dialogs:
			if dialog['name'] == dialogName:
				if value == None:
					self.setCurrentStepByName(dialog['next'])
				else:
					self.setCurrentStepByName(dialog['next'][value])
				return True
			step = step + 1
		return False

	def backForDialog(self, dialogName, value = None):
		"""Перейти на предыдущий шаг с диалога dialogName"""
		step = 0
		for dialog in self.dialogs:
			if dialog['name'] == dialogName:
				if value == None:
					self.setCurrentStepByName(dialog['back'])
				else:
					self.setCurrentStepByName(dialog['back'][value])
				return True
			step = step + 1
		return False
	
	def nextStep(self):
		"""Перейти на следующий шаг"""
		self.setCurrentStep(self.getCurrentStep() + 1)

	def back(self):
		"""Вернуться на предыдущий по истории шаг"""
		self.setCurrentStep(self.oldStep)
		
	def previousStep(self):
		"""Перейти на предыдущий шаг"""
		if self.currentStep > 0:
			self.setCurrentStep(self.getCurrentStep() - 1)

	def setCurrentStepByName(self, name):
		"""Задать текущий шаг по имени диалога"""
		step = 0
		for dialog in self.dialogs:
			if dialog['name'] == name:
				self.setCurrentStep(step)
				return True
			step = step + 1
		return False

	def showCurrentDialog(self):
		"""Вывести текущий диалог"""
		self.dialogs[self.currentStep]['function']()

	def setCurrentStep(self, currentStep):
		"""Задать текущий шаг"""
		self.oldStep = self.currentStep
		self.currentStep = currentStep

	def getCurrentStep(self):
		"""Получить текущий шаг"""
		return self.currentStep

	def close(self):
		self.isExit = True
