#!/usr/bin/env python3

"""
Скрипт принимает в качестве входных аргументов имена файлов скриптов и записывает в файл для дальнейшей обработки
механизмом first_run
"""

import os
import sys

def save_to_regexp_file(param: str, regexp_filename: str) -> None:
	"""
	Записать параметр param в файл regexp_filename
	"""
	print(param)
	if not os.path.exists(regexp_filename):
		os.makedirs(os.path.dirname(regexp_filename), exist_ok=True)
		regexp_file = open(regexp_filename, "w")
		regexp_file.write(param + "\n")
		regexp_file.close()
	else:
		regexp_file = open(regexp_filename)
		content = regexp_file.readlines()
		regexp_file.close()
		isExist = False
		for line in content:
			if param == line.strip():
				isExist = True
				break
		if not isExist:
			regexp_file = open(regexp_filename, "a")
			regexp_file.write(param + "\n")
			regexp_file.close()

def main():
	regexp_filename = None
	if len(sys.argv) > 1:
		regexp_filename = "/linuxcash/cash/data/tmp/first-run-executed-scripts"
		params = sys.argv[1:]
		for param in params:
			save_to_regexp_file(param, regexp_filename)

if __name__ == "__main__":
	os.chdir(os.path.dirname(os.path.abspath(__file__)))
	main()