#!/usr/bin/python3

import re, os

class MenuItem(object):
    label = ''
    script = ''

    def __init__(self, label, script):
        self.label = label
        self.script = script

    @staticmethod
    def createItemFromFile(fileName):
        try:
            for line in open(fileName, 'r'):
                m = re.match('^#item\{([^\}]+)\}', line)
                if m:
                    return MenuItem(label=m.group(1), script=fileName)
        except:
            return None

def listItems(menudir):

    def createItem(fileName):
        if os.path.isfile('%s/%s' % (menudir,fileName)) and re.match('^([\d]+)_', fileName):
            return MenuItem.createItemFromFile('%s/%s' % (menudir,fileName))

    l = os.listdir(menudir)
    l.sort()

    return filter(lambda x: x, map(lambda x: createItem(x), l))
